dofile("GUI/iup_layout.lua")
dofile("GUI/iup_callbacks.lua")
dofile("GUI/view_config.lua")
dofile("GUI/view_search.lua")
dofile("GUI/view_sector.lua")
dofile("GUI/view_universe.lua")

function PR.GUI.Refresh()
    for i = 1, PR.GUI.MaxDisplayRows do PR.GUI.DisplayPanel[i] = nil end
    PR.GUI.DisplayPanel[1] = "No data available"
    PR.GUI.MaxDisplayRows = 1
    PR.GUI.ListedItems = {}

    PR.GUI.Btn_Top1.title = PR.GUI.View
    PR.GUI.Btn_Top2.title = ""
    PR.GUI.Btn_Top2.fgcolor = PR.GUI.Color.Button
    PR.GUI.Btn_Top3.title = ""
    PR.GUI.Btn_Top3.fgcolor = PR.GUI.Color.Button
    PR.GUI.Btn_Top4.title = ""
    PR.GUI.Btn_Top4.fgcolor = PR.GUI.Color.Button
    PR.GUI.UserInput.value = ""
    iup.Detach(PR.GUI.EditBox)
    PR.GUI.Btn_Bottom3.title = ""

    if PR.GUI.View == "Sector" then
        PR.GUI.RefreshSectorBox()
        -- for faster checking by PR.TargetScanned to update temps
        PR.GUI.CurrentSectorShowing = PR.GUI.DisplayedSector == PR.LoadedSector
    else
        PR.GUI.CurrentSectorShowing = false
        if PR.GUI.View == "Universe" then
            PR.GUI.RefreshUniverseBox()
        elseif PR.GUI.View == "Search" then
            PR.GUI.RefreshSearchBox()
        elseif PR.GUI.View == "Config" then
            PR.GUI.RefreshConfigBox()
        end
    end
    iup.Refresh(PR.GUI.MainDialog[1][1])
end

function PR.GUI.ShowGUI()
    if PR.PluginReady then
        -- force a pending update
        PR.SaveNow()
        -- refresh dialog contents, needs to be done before showing it
        PR.GUI.DisplayedSector = 0
        PR.GUI.Refresh()
        -- make it wider on small resolution screens
        if tonumber(HUDSize(1)) < 1000 then PR.GUI.MainDialog.size = "500xTHREEQUARTER" end

        -- show as either modal popup or regular dialog
        -- (checking iup.Popup exists because apparently the devs consider
        -- removing it due to issues in combination with long-press action,
        -- on mobile, but that was back in 2014 and it seems to work fine)
        if HUD.visible and PR.GUI.HasPopup then
            -- when the HUD is shown, show as a popup to prevent clicking on
            -- the HUD and bring it to the front
            iup.Popup(PR.GUI.MainDialog, iup.CENTER, iup.CENTER)
        else
            -- if the HUD is not shown, we show a regular dialog so the user
            -- can interact with the UI behind
            PR.GUI.MainDialog:show()
        end
    else
        PR.Print("Prospector not ready yet, please wait.")
    end
end

function PR.GUI.Close()
    PR.GUI.MainDialog:hide()
    -- free some memory
    for i = 1, PR.GUI.MaxDisplayRows do PR.GUI.DisplayPanel[i] = nil end
    PR.GUI.SectorRoidList = {}
    PR.GUI.SystemData = {}
    PR.GUI.CurrentSectorShowing = false
    return iup.CLOSE
end
